 /* TFTDExtender - Mod for X-COM: Terror from the Deep
 * NOTE: This project is unfinished. Some of the code is obsolete, useless, or detrimental. Use at your own risk.
 * Original UFO Extender is copyright (C) 2008-2010 Seb76. Initial conversion for X-COM: Terror from the Deep was implemented by Xusilak.
 * Further conversion and updates by <Morgan525/Tycho> with thanks to Kyrub for his contributions.
 * TFTD Patcher is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

 * TFTD Patcher is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along with TFTD Patcher.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once


#define EQUIPMENT


#define INI_FILE "./TFTDExtender.ini"
#define INI_READ_INT(section,key,default) GetPrivateProfileIntA(section,key,default,INI_FILE)
#define INI_READ_STRING(section,key,default,buf,size) GetPrivateProfileStringA(section,key,default,buf,size,INI_FILE)

#define EXPORT_ONCE __declspec(selectany)
// Data imported from the original executable


typedef struct  
{
  unsigned char Unit_Type;				//0
  char Paper_Doll;
  char Unknown1;
  char Unknown2;
  char Unknown3;
  char Unknown4;
  char Unknown5;
  char Unknown6;
  char Unknown7;
  char Unknown8;
  char Facing;					//10
  char MovementType;
  unsigned char TUs_Current;
  char HPs_Current;
  char Stun;
  char EUs_Current;
  char React_Current;
  char Strength;
  char F_Armor_Current;
  char L_Armor_Current;
  char R_Armor_Current;			//20
  char B_Armor_Current;
  char U_Armor_Current;
  char Firing_Acc;
  char Throw_Acc;
  unsigned char TUs_Max;
  char HPs_Max;
  char EUs_Max;
  char React_Max;
  char F_Armor_Max;
  char L_Armor_Max;				//30
  char R_Armor_Max;
  char B_Armor_Max;
  char U_Armor_Max;
  char UnknownA;
  char EU_Recharge;
  char UnknownB;
  char Psi_Skill;
  char obdata_index;
  char VPs;
  unsigned char soldier_index;			//40
  char UnknownC;
  char Rank;
  char UnknownD;
  char Aggression;
  char EU_Usage;
  char HWP_Turret;
  char UnknownE;
  char UnknownF;
  char Stand_Height;
  char Crouch_Height;			//50
  char UnknownG;
  char UnknownH;
  char L_Hand_Item;
  char R_Hand_Item;
  char UnknownI;
  char Close_Acc;
  char Psi_Strength;
  char Morale;
  char Bravery;
  char UnknownJ;				//60
  char UnknownK;
  char Scanner_Blip;
  char Head_Fatal;
  char Torso_Fatal;
  char R_Arm_Fatal;
  char L_Arm_Fatal;
  char R_Leg_Fatal;
  char L_Leg_Fatal;
  char UnknownL;
  char UnknownM;				//70
  char UnknownN;
  char UnknownO;
  char Intelligence;
  char UnknownP;
  char UnknownQ;
  char Mission_Count;
  char UnknownR;
  short Kills;
  char React_Count;				//80
  char Shot_Count;
  char Rod_Count;
  char Throw_Count;
  char Psi_Count;
  char Panic_Count;				//85
  char Name[26];
  char UnknownS;
  char Inventory_Access;
  char On_Fire;
  char Gender;
  char Race;
  char Turret_Weapon;
  char Turret_Ammo;				//118
  char Unknown;
  char Bitflags;
  char UnknownT;
  char UnknownU;
  char UnknownV;				//123
  char UnknownW;
  char UnknownX;
  char UnknownY;
  char UnknownZ[5];
}
unitref_dat;

typedef struct
{
	unsigned char itemType;
	unsigned char ypos;
	unsigned char xpos;
	unsigned char zpos;
	unsigned char owner;
	unsigned char slot;
	unsigned short container;
	unsigned char quantity1;
	unsigned char quantity2;
	unsigned char quantity3;
	unsigned char height_offset;
	unsigned int flags;
}
obpos_dat;


EXPORT_ONCE int (*GetUnitEncumberance)(int)=(int (__cdecl *)(int))0x414B70;
EXPORT_ONCE void (*DrawNumber)(int number, int color, int dst, __int16 useSmallFont)=(void (__cdecl *)(int,int,int,short))0x458F00;
EXPORT_ONCE void (*DrawNumber2)(int number, int color, __int16 ypos, __int16 xpos, int useSmallFonts)=(void (__cdecl *)(int,int,__int16,__int16,int))0x458FF0;

EXPORT_ONCE void (*DrawSmallLetter)(int chr, int col, int dst)=(void (__cdecl *)(int,int,int))0x458B50;
EXPORT_ONCE void (*DrawString)(const char *str, int color, __int16 ypos, __int16 xpos, int smallFont)=(void (__cdecl *)(const char *str, int color, __int16 ypos, __int16 xpos, int smallFont))0x458690;
EXPORT_ONCE int (*UpdateRadarStats)(int base)=(int (__cdecl *)(int))0x43DC10;
EXPORT_ONCE int (*GetRandom_0_n)(int n)=(int (__cdecl *)(int))0x441720;  // KY done

EXPORT_ONCE int (*LoadFile)(void *dstbuf, int filename)=(int (__cdecl *)(void *,int))0x43F480;
EXPORT_ONCE int (*AlienTakeActionAfterShootDown)(void *pUFOCraft, void * pAttackingCraft)=(int (__cdecl *)(void *,void *))0x436260;
                            
EXPORT_ONCE int (*GetClickedButton)()=(int (__cdecl *)())0x4593F0;
EXPORT_ONCE int (*LoadGFXRessources)(__int16 resourcePackId)=(int (__cdecl *)(__int16 resourcePackId))0x40A1A0;
EXPORT_ONCE int (*DrawRankIcon)(int dst, int src, int width)=(int (__cdecl *)(int dst, int src, int width))0x428820;
EXPORT_ONCE int (*Tactical_KillUnit)(int)=(int (__cdecl *)(int))0x40EE00;
EXPORT_ONCE int (*Tac_RenderUnitKO)(int)=(int (__cdecl *)(int))0x40F240;
EXPORT_ONCE void (*LoadTacticalGame)(char *)=(void (__cdecl *)(char *))0x418AB0;
EXPORT_ONCE void (*LoadGeographGame)(char *)=(void (__cdecl *)(char *))0x450BC0;
EXPORT_ONCE void (*TacticalDrawErrorMessage)()=(void (__cdecl *)())0x40A890;
                            
EXPORT_ONCE void (*SaveTacticalData)(char *)=(void (__cdecl *)(char *))0x417BB0;
EXPORT_ONCE int (*PerformReactionFire)()=(int (__cdecl *)())0x410450;
EXPORT_ONCE void (*ComputeVisibleAliens)(int xpos, int ypos, int zpos, __int16 orientation, __int16 distance)=(void (__cdecl *)(int xpos, int ypos, int zpos, __int16 orientation, __int16 distance))0x432100;
EXPORT_ONCE int (*AdjustShotWithAccuracy)()=(int (__cdecl *)())0x40E470;
EXPORT_ONCE int (*DD_SurfaceUnlock)()=(int (__cdecl *)())0x465AD0;
EXPORT_ONCE unsigned char * (*DD_SurfaceLock)()=(unsigned char * (__cdecl *)())0x465A70;
EXPORT_ONCE int (*DD_SurfaceFlip)()=(int (__cdecl *)())0x465AF0;  // KY done
EXPORT_ONCE void (*sub_422850)(int Cur_Unit_UniPos_Num)=(void (__cdecl *)(int Cur_Unit_UniPos_Num))0x422850;

EXPORT_ONCE short *language=(short *)0x494842;
EXPORT_ONCE int *carretPosition=(int *)0x4D6354;
EXPORT_ONCE unitref_dat **currentUnit_pUnitRef=(unitref_dat **)0x4D6268;
EXPORT_ONCE unitref_dat **file_missdat_uniref_dat=(unitref_dat **)0x4D93C0;

EXPORT_ONCE short *unitIdx=(short *)0x48E4D8;
EXPORT_ONCE short *tactical_mainState=(short *)0x48E274;
EXPORT_ONCE short *geoscape_mainState=(short *)0x4CBBF4;
EXPORT_ONCE short *zoomGeoGlobe=(short *)0x479D3C;

EXPORT_ONCE int *CurrentMidiPlaying=(int *)0x48BA6C;
EXPORT_ONCE short *currentBaseIdx=(short *)0x4CB4A8;
EXPORT_ONCE short *tac_turn=(short *)0x48E340;
EXPORT_ONCE short *tac_debug=(short *)0x48DC62;
EXPORT_ONCE short *tac_debug_alienPuppies=(short *)0x4775D6;
EXPORT_ONCE short *tac_currentTUReserveMode=(short *)0x48E586;
EXPORT_ONCE short *difficultyLevel=(short *)0x4CC23E;
EXPORT_ONCE short *geo_timeSpeed=(short *)0x4CB494;
EXPORT_ONCE int (*GetTime)()=(int (__cdecl *)())0x467C80;


EXPORT_ONCE char *tac_misdata=(char *)0x4D6280;
EXPORT_ONCE unsigned char **locationList=(unsigned char **)0x4CB490;
EXPORT_ONCE unsigned char **craftList=(unsigned char **)0x4CB4F8;

EXPORT_ONCE char **StringTable_geoscape=(char **)0x4AACE4;
EXPORT_ONCE char **StringTable_battlescape=(char **)0x4D4AE0;
 
EXPORT_ONCE short *DrawText_leftBorder=(short *)0x48E346;
EXPORT_ONCE short *DrawText_rightBorder=(short *)0x48E348;
EXPORT_ONCE short *currentGFXPackage=(short *)0x48E33E;

EXPORT_ONCE short **smokeTabRessources=(short **)0x4E093C;
EXPORT_ONCE char **smokePCKRessources=(char **)0x4D6368;
EXPORT_ONCE char **BackBuffer=(char **)0x4E0930;

EXPORT_ONCE char *IsDuringInitialUPSExplosion=(char *)0x48DF44;
                    
EXPORT_ONCE char *unitpos_dat=(char *)0x4D5020;
EXPORT_ONCE unsigned char **file_geodata_obdata_dat=(unsigned char **)0x4D6338;

EXPORT_ONCE short *currentWeapon_damageType=(short *)0x48E50E;

EXPORT_ONCE short *map_numTilesPerLevel=(short *)0x4D5518;
EXPORT_ONCE int **pMap=(int **)0x4D5528;
EXPORT_ONCE unsigned char **pSeeMap=(unsigned char **)0x4E09E0;

EXPORT_ONCE unsigned char *pGeodata=(unsigned char *)0x4D9360;

EXPORT_ONCE unsigned char **pBaseDat=(unsigned char **)0x4CB4B8;

EXPORT_ONCE unsigned char *Tac_Show_LaunchRocket_Icon=(unsigned char *)0x48E34F;
EXPORT_ONCE unsigned char *Tac_numRocketWayPoints=(unsigned char *)0x4947C8;


EXPORT_ONCE short *Tac_RocketWayPoints=(short *)0x4CD520;
EXPORT_ONCE short **file_ufograph_cursor_tab=(short **)0x4D9300;
EXPORT_ONCE char **file_ufograph_cursor_pck=(char **)0x4D85B0;
EXPORT_ONCE int (*DrawPCKSprite)(__int16, __int16, int, int)=(int (__cdecl *)(__int16,__int16,int,int))0x433D50;

EXPORT_ONCE short *mouse_num_click1=(short *)0x4D634E;
EXPORT_ONCE short *mouse_num_click2=(short *)0x4D7DC8;

EXPORT_ONCE short *mouse_xpos_click_2=(short *)0x4D634A;
EXPORT_ONCE short *mouse_ypos_click_2=(short *)0x4D634C;

EXPORT_ONCE short *mouseCursorId=(short *)0x48E268;
EXPORT_ONCE int *mouse_buttons=(int *)0x478AB0;

EXPORT_ONCE short *tac_currentTile_xpos=(short *)0x48E264;
EXPORT_ONCE short *tac_currentTile_ypos=(short *)0x48E262;

EXPORT_ONCE short *tac_xview=(short *)0x48E26C;
EXPORT_ONCE short *tac_yview=(short *)0x48E26A;
EXPORT_ONCE short *tac_zview=(short *)0x475972;


EXPORT_ONCE unsigned char **currentUnit_pUnitPos=(unsigned char **)0x4D85C0;
EXPORT_ONCE void (*SetFiringPointOrigin)(unsigned char *)=(void (__cdecl *)(unsigned char *))0x40E270;

EXPORT_ONCE short *accuracy=(short *)0x48E546;
EXPORT_ONCE short *WeaponMenu_NumEntries=(short *)0x48E4F0;

typedef struct 
{
	short actionType;
	short accuracy;
	short TUusage;
	short weaponStrength;
	short damageType;
} 
menu_item;

EXPORT_ONCE menu_item *WeaponMenu_Items=(menu_item *)0x4D9320;
EXPORT_ONCE short *WeaponMenu_ClickedItem=(short *)0x48E298;


EXPORT_ONCE short *currentWeapon_damage=(short *)0x48E50C;

EXPORT_ONCE void (*SetTacticalViewPos)(int ypos, int xpos, __int16 zpos)=(void (__cdecl *)(int ypos, int xpos, __int16 zpos))0x412DD0;

EXPORT_ONCE void (*DoDamageToShotTile)()=(void (__cdecl *)())0x40E620;
EXPORT_ONCE void (*FixShotTile)()=(void (__cdecl *)())0x42AF70;
                            
EXPORT_ONCE short *Tactical_weaponHasHitSomeone=(short *)0x4D48EA;
EXPORT_ONCE short *Tactical_weaponHasHitSomething=(short *)0x4D48F0;

EXPORT_ONCE short *impactArmorSide=(short *)0x4D48F8;
EXPORT_ONCE void (*Tactical_DoDamageToUnit)(__int16 impactSide, __int16 playAnimation)=(void (__cdecl *)(__int16 impactSide, __int16 playAnimation))0x40E830;

EXPORT_ONCE short *Tactical_StatusErrorMessage=(short *)0x48E280;

EXPORT_ONCE int (*GetRelativePositioning)(int y1, int x1, int y2, int x2)=(int (__cdecl *)(int y1, int x1, int y2, int x2))0x424A60;
EXPORT_ONCE void (*TryChangeUnitOrientation)(int pUnitPos, int orientation)=(void (__cdecl *)(int pUnitPos, int orientation))0x424B00;


EXPORT_ONCE short *currentUnit_ypos=(short *)0x48E278;
EXPORT_ONCE short *currentUnit_xpos=(short *)0x48E27A;
EXPORT_ONCE short *currentUnit_zpos=(short *)0x48E27C;
EXPORT_ONCE short *currentUnit_idx=(short *)0x48E27E;


EXPORT_ONCE int *mouse_ypos=(int *)0x478AB8;
EXPORT_ONCE int *mouse_xpos=(int *)0x478AB4;
                            

EXPORT_ONCE short *needsToUpdateTerrainLightSources=(short *)0x4CD658;
EXPORT_ONCE short *needsToUpdateSoldiersLightSources=(short *)0x4D4902;

EXPORT_ONCE void (*TacticalComputeTerrainLightSources)()=(void (__cdecl *)())0x41A940;
EXPORT_ONCE void (*TacticalComputeSoldiersLightSources)()=(void (__cdecl *)())0x41A780;

EXPORT_ONCE char **currentDamagedUnit_pUnitPos=(char **)0x4D491C;
EXPORT_ONCE void (*GenerateExplosion)(int xpos, int ypos, __int16 zpos, int strength, int, int, __int16)=(void (__cdecl *)(int xpos, int ypos, __int16 zpos, int strength, int, int, __int16))0x40BD00;
EXPORT_ONCE void (*Draw16x16Sprite)(int distance, int blipsize)=(void (__cdecl *)(int, int))0x40B4D0;
EXPORT_ONCE void (*WakeUnitUp)(char object_idx, int unitpos_ref, int unitref_ref)=(void (__cdecl*)(char objidx, int unitpos, int unitref))0x4149B0;

#pragma pack(1)
typedef struct
{
	short active;
//	unsigned char *pObpos;
	obpos_dat *pObpos;
} prox_entry;

EXPORT_ONCE prox_entry *tac_prox_mine_list=(prox_entry *)0x48E2A0;
//EXPORT_ONCE unsigned char *pObpos_dat=(unsigned char *)0x4A5FE0;
EXPORT_ONCE obpos_dat *pObpos_dat=(obpos_dat *)0x4D85E0;

EXPORT_ONCE void (*ActAccordingToTacticalState)()=(void (__cdecl *)())0x422F70;

EXPORT_ONCE void (*SetCurrentUnit)(int)=(void (__cdecl *)(int))0x4234A0;

//EXPORT_ONCE short *map_numTilesPerLevel=(short *)0x4A3134;
EXPORT_ONCE short *tac_mapZSize=(short *)0x4D85B8;

EXPORT_ONCE void (*CreateButton)(int,int,int,int,int,char *)=(void (__cdecl *)(int,int,int,int,int,char *))0x4591E0;
EXPORT_ONCE void (*WaitTillMouseButtonsAreReleased)()=(void (__cdecl *)())0x441790;
EXPORT_ONCE int (*CheckForClickedButton)()=(int (__cdecl *)())0x4594D0;
EXPORT_ONCE short *ui_numButtons=(short *)0x49483A;
EXPORT_ONCE short (*GetFreeObPosRef)()=(short (__cdecl *)())0x40F5B0;
EXPORT_ONCE void (*SpawnAlienStuff_asm)()=(void (__cdecl*)())0x457830;
EXPORT_ONCE void (*SpawnXcomStuff_asm)()=(void (__cdecl*)())0x456BD0;

EXPORT_ONCE void (*UpdateAirborneShipsPosition)()=(void (__cdecl *)())0x4600A0;
EXPORT_ONCE short *numAirborneShips=(short *)0x4CB50C;
EXPORT_ONCE short *numUfosInRetaliationMission=(short *)0x4CBC0A;
EXPORT_ONCE short *numHiddenAlienShips=(short *)0x4CC30A;
EXPORT_ONCE short *nextSpottedUFONumber=(short *)0x479D90;
EXPORT_ONCE void (*SiteTooDeepMsg)()=(void (__cdecl *)())0x463700;
EXPORT_ONCE void (*RecallShip)()=(void (__cdecl *)())0x45B220;
                               
EXPORT_ONCE int (*GetCountryFromPos)(__int16,__int16)=(int (__cdecl *)(__int16,__int16))0x4623B0;
EXPORT_ONCE int (*GetWorldZoneFromPos)(__int16,__int16)=(int (__cdecl *)(__int16,__int16))0x462350;
EXPORT_ONCE int (*IsPointOnWater)(unsigned short,unsigned short)=(int (__cdecl *)(unsigned short,unsigned short))0x461240;
//EXPORT_ONCE int (*IsPointOnWater)(int,int)=(int (__cdecl *)(int,int))0x458700;
EXPORT_ONCE void (*RotateGlobeToLocation)(__int16 locationIdx)=(void (__cdecl *)(__int16 locationIdx))0x461BC0;

EXPORT_ONCE unsigned char **file_geodata_world_dat=(unsigned char **)0x4CC230;

EXPORT_ONCE void (*LoadGeographBackScreen)(short)=(void (__cdecl *)(short))0x443020;
EXPORT_ONCE void (*LoadGeodataBackPalette)(short)=(void (__cdecl *)(short))0x464280;

EXPORT_ONCE int (*DrawDottedLine)(int col, int, char)=(int (__cdecl *)(int col, int, char))0x04430E0;

EXPORT_ONCE short *Dialog_ClickedItem=(short *)0x4CBC04;

                               
EXPORT_ONCE short (*GeoPerformDailyActions)()=(short (__cdecl *)())0x445880;

EXPORT_ONCE int *IsTacticalMode=(int *)0x4949B4;
EXPORT_ONCE int *HasKeyBeenPressed=(int *)0x4949A4;    // doubtful, could be CheckKeyPressed KY
                                
EXPORT_ONCE void (*DI_AcquireState)()=(void (__cdecl *)())0x467B00;
EXPORT_ONCE unsigned char *DI_KeyStateBuffer=(unsigned char *)0x494CA0;
EXPORT_ONCE void (*DI_GetPressedKey)()=(void (__cdecl *)())0x467BD0;


EXPORT_ONCE void (*StatusBarClicked)(short)=(void (__cdecl *)(short icon))0x413AE0;
EXPORT_ONCE void (*CheckIfClickedOnStatusBar)()=(void (__cdecl *)())0x4137B0;

EXPORT_ONCE short *inventory_draggedItem_obPosIdx=(short *)0x48E4E0;
EXPORT_ONCE short *inventory_draggedItem_objectType=(short *)0x476D04;

EXPORT_ONCE int (*GetDistance)(int x1, int y1, int x2, int y2)=(int (__cdecl *)(int x1, int y1, int x2, int y2))0x41A740;

EXPORT_ONCE void (*ShowSoldierStats)(char *)=(void (__cdecl *)(char *pUnitPos))0x40AC70;

EXPORT_ONCE void (*CreateAlienBase)(int zone, char race)=(void (__cdecl *)(int zone, char race))0x435EB0;
EXPORT_ONCE void (*CreateXComBase)(__int16 isInitialBase)=(void (__cdecl *)(__int16 isInitialBase))0x43BD10;


EXPORT_ONCE void (*AddDialogButton)(__int16 xPos, __int16 type)=(void (__cdecl *)(__int16 xPos, __int16 type))0x442020;
EXPORT_ONCE unsigned short *DlgNumButtons=(unsigned short *)0x4CB4BC;
EXPORT_ONCE unsigned short *DlgUpperLowerButtonPressed=(unsigned short *)0x4CB4FC;
EXPORT_ONCE unsigned short *DlgDialog_ClickedItem=(unsigned short *)0x4CBC04;
EXPORT_ONCE unsigned short *DlgNumItems=(unsigned short *)0x4CC234;
EXPORT_ONCE unsigned short *DlgItemIdList=(unsigned short *)0x4CB240;
EXPORT_ONCE unsigned char **pSoldierDat=(unsigned char **)0x4CC374;

EXPORT_ONCE int (*CheckHasLineOfFire)(__int16 ypos, __int16 xpos, __int16 zpos)=(int (__cdecl *)(__int16 ypos, __int16 xpos, __int16 zpos))0x42EBB0;
//EXPORT_ONCE int (*CheckIfClickedOnUnit)(__int16 ypos, __int16 xpos, __int16 zpos)=(int (__cdecl *)(__int16 ypos, __int16 xpos, __int16 zpos))0x4233F0;

EXPORT_ONCE int firstBaseTemplate=0x4798A8; //unsigned char to int

EXPORT_ONCE int (*GetSoldierScoreForPromotion)(__int16 soliderIdx)=(int (__cdecl *)(__int16 soliderIdx))0x44D7B0;


//init some variables related to moving/opening doors
EXPORT_ONCE int (*sub_422B60)(__int16 ypos, __int16 xpos, __int16 zpos, int, int, int orientation, int movementType)=(int (__cdecl *)(__int16 ypos, __int16 xpos, __int16 zpos, int, int, int orientation, int movementType))0x425E20;

EXPORT_ONCE	void (*OpenFacingDoor)(int doorType)=(void (__cdecl *)(int doorType))0x4243F0;
EXPORT_ONCE unsigned short *MustGoThroughDoor=(unsigned short *)0x48E31C;

EXPORT_ONCE	void (*UpdateCurrentlyFacedTile)()=(void (__cdecl *)(void))0x420C80;
EXPORT_ONCE unsigned char *facingTile_ypos=(unsigned char *)0x48E343;
EXPORT_ONCE unsigned char *facingTile_xpos=(unsigned char *)0x48E344;
EXPORT_ONCE unsigned char *facingTile_isValid=(unsigned char *)0x48E345;

EXPORT_ONCE unsigned char (*GetTileHeight)(__int16 ypos, __int16 xpos, __int16 zpos)=(unsigned char (__cdecl *)(__int16 ypos, __int16 xpos, __int16 zpos))0x411D00;

EXPORT_ONCE	void (*UpdateSeeMapAndVisibleEnemies)()=(void (__cdecl *)(void))0x431410;
EXPORT_ONCE	void (*DrawMouseCursor)()=(void (__cdecl *)(void))0x433370;

EXPORT_ONCE	void (*myfflush)(FILE *)=(void (__cdecl *)(FILE *))0x46977B;

EXPORT_ONCE	void (*GeoHandleLeftClick)()=(void (__cdecl *)(void))0x459700;

#pragma pack(1)
typedef struct
{
	unsigned char r;
	unsigned char g;
	unsigned char b;
} palette_entry;

EXPORT_ONCE palette_entry *palette=(palette_entry *)0x4CD140;

EXPORT_ONCE	void (*Tactical_EquipTeamDisplay)()=(void (__cdecl *)(void))0x41C950;

EXPORT_ONCE	void (*Tactical_TestForEndOfBattle)()=(void (__cdecl *)(void))0x415D90;

EXPORT_ONCE unsigned char *tac_ambient_light=(unsigned char *)0x4D48F2;

EXPORT_ONCE	unsigned char (*sub_41F8C0)(__int16 unknow, __int16 uniposIdx, __int16 objType)=(unsigned char (__cdecl *)(__int16, __int16 uniposIdx, __int16 objType))0x41F8C0;

EXPORT_ONCE	void (*InitNewGeoGame)()=(void (__cdecl *)(void))0x43EBA0;

EXPORT_ONCE	void (*SaveGeoGameData)(char *)=(void (__cdecl *)(char *slot))0x44FCE0;


EXPORT_ONCE	void *(*LoadResourceFile)(char *)=(void *(__cdecl *)(char *lpFileName))0x43F380; //error:409DB0;

EXPORT_ONCE unsigned char *isDuringReactionFire=(unsigned char *)0x48E508;

EXPORT_ONCE int (*sub_410820)(__int16 uniposNum)=(int (__cdecl *)(__int16 uniposNum))0x410820;

EXPORT_ONCE	void (*TacticalDrawPanicMessage)(int unitIdx)=(void (__cdecl *)(int unitIdx))0x422BA0;

EXPORT_ONCE unsigned char *tac_playing_side=(unsigned char *)0x48E260;

EXPORT_ONCE unsigned short *geo_num_rearming_crafts=(unsigned short *)0x4CB440;

EXPORT_ONCE	void (*ShowSoldierStat)(int soldierIdx, __int16 baseLocIdx)=(void (__cdecl *)(int soldierIdx, __int16 baseLocIdx))0x443580;

EXPORT_ONCE int* money = (int*)0x4CBAF0;
EXPORT_ONCE short* geo_currentHour = (short*)0x4CB49C;
EXPORT_ONCE short* geo_currentMinute = (short*)0x4CB484;
EXPORT_ONCE short* geo_currentSecond = (short*)0x4CC308;
EXPORT_ONCE short* geo_currentDayOfTheWeek = (short*)0x4CB47C;
EXPORT_ONCE short* geo_currentDay = (short*)0x4CBC06;
EXPORT_ONCE short* geo_currentMonth = (short*)0x4CBB98;
EXPORT_ONCE short* geo_currentYear = (short*)0x4CB224;
EXPORT_ONCE void* file_geograph_geobord_scr = (void*)0x4CC330;
EXPORT_ONCE char** StringsTable_geoscape = (char**)0x4AACE8;
EXPORT_ONCE short* month_names_index = (short*)0x47E690;
EXPORT_ONCE char** languageStuff_geoscape = (char**)0x4AACE0;
EXPORT_ONCE char* DrawNumber2_useThousandSeparator = (char*)0x4CB49A;
EXPORT_ONCE char* ProductDat = (char*)0x47AA90;
EXPORT_ONCE char** BProdDat = (char**)0x4CB4B0;
EXPORT_ONCE char* PurchaseDat = (char*)0x47AEA8;
EXPORT_ONCE char** BaseDat = (char**)0x4CB4B8;

#pragma pack(push,1)

typedef struct
{
	unsigned char ypos;
	unsigned char xpos;
	unsigned char zpos;
	unsigned char unk0;
	unsigned int unitRefPtr;
	unsigned char detected;
	unsigned char owner;
	unsigned char flags;
	unsigned char unk1;
	unsigned char unk2;
	unsigned char unk3;
}
unitpos_datx;
#pragma pack(pop)

EXPORT_ONCE unitpos_datx *file_missdat_unipos_dat=(unitpos_datx *)0x4D5020;

//Functions
EXPORT_ONCE int (*BlitToBackBuffer)(int src) = (int (__cdecl*)(int src))0x4430C0;   // KY used for less things ???

EXPORT_ONCE unsigned char *(*GetTileAt)(__int16 xpos, __int16 ypos, __int16 zpos) = (unsigned char *(__cdecl*)(__int16 xpos, __int16 ypos, __int16 zpos))0x419B10;

EXPORT_ONCE short* clickedUnit_unitpos = (short*)0x4D5538; //global that stores the position of the unit clicked
EXPORT_ONCE int* clickedUnit_idx = (int*)0x48E4FC; //global that stores the index of the unit clicked
EXPORT_ONCE unitpos_datx* UnitposDat = (unitpos_datx*)0x4D5020;  // KY DONE !!!

